#include <iostream>

#include "dyn"

#define debug(var) do{ \
    std::cout << #var << " = " << (var).getvalue() << ": "; \
    (var).debug(); \
    std::cout << std::endl; }while(0) \

int main(void)
{
    try {
    dyn<int> a,b,c,d;
    
    a = 1;
    b = 2;
    c = a+b;
    
    debug(a);
    debug(b);
    debug(c);
    
    std::cout << "Muutetaan a 9:ksi\n";
    
    a = 9;
    debug(a);    
    debug(b);
    debug(c);
    
    std::cout << "Listn 4 * b\n";
    
    for(int i=0; i<4; ++i)
        c += b;
        
    debug(c);
    
    std::cout << "Listn c\n";
    c += c;
    
    debug(c);
    
    std::cout << "Kerrotaan viidell\n";
    
    c *= 5;
    
    debug(c);
    
    std::cout << "Muutetaan b kolmeksi\n";
    
    b = 3;

    debug(b);
    debug(c);
    
    std::cout << "Suoritetaan: c = (b+a*3+7*(a/c)%b);\n";
    c = (b + a * 3); //+ 7 * (a / c) % b);
    
    debug(a);
    debug(b);
    debug(c);
    
    } catch(dynerror tmp)
    {
        std::cerr << "DYN: " << tmp << std::endl;
    }
    
    return 0;
}
